var J = Object.defineProperty;
var Y = (t, e, s) => e in t ? J(t, e, { enumerable: !0, configurable: !0, writable: !0, value: s }) : t[e] = s;
var h = (t, e, s) => (Y(t, typeof e != "symbol" ? e + "" : e, s), s);
import V from "cac";
import a from "picocolors";
import P from "readline";
import { createLogger as Q, createServer as X } from "vite";
import { loadConfig as Z } from "unconfig";
import $ from "fs";
import x, { resolve as k, relative as ee } from "path";
import "url";
import { resolve as te } from "pathe";
import H from "fast-glob";
import { parse as se } from "acorn";
import re from "magic-string";
import { isMatch as ne, match as ie } from "micromatch";
import { WebSocketServer as oe, WebSocket as ae } from "ws";
import { z as g } from "zod";
import ce from "chokidar";
import le from "events";
import j from "prompts";
const fe = "[viteburner]";
function ue(t = "", e = "", s = "") {
  const r = [];
  return t && r.push(a.green(t)), e && r.push(a.dim(e)), s && r.push(s), r.join(" ");
}
function me(t) {
  return a.yellow(`${t}`);
}
function de(t) {
  return a.red(`${t}`);
}
function pe() {
  const t = {
    base: Q("info", { prefix: fe, allowClearScreen: !1 }),
    info: (...e) => t.base.info(ue(...e), { timestamp: !0, clear: !1 }),
    warn: (...e) => t.base.warn(me(e.join(" ")), { timestamp: !0, clear: !1 }),
    error: (...e) => t.base.error(de(e.join(" ")), { timestamp: !0, clear: !1 })
  };
  return t;
}
const i = pe();
function he(t) {
  process.stdin.isTTY || i.warn("current stdin is not a TTY. Keypress events may not work.");
  let e = !1;
  async function s(c, l) {
    (c === "" || c === "\x1B" || l && l.ctrl && l.name === "c") && (i.info("sigterm"), process.exit(1)), !e && (e = !0, await t({ str: c, key: l, on: n, off: o }), e = !1);
  }
  let r;
  function n() {
    o(), r = P.createInterface({ input: process.stdin }), P.emitKeypressEvents(process.stdin, r), process.stdin.isTTY && process.stdin.setRawMode(!0), process.stdin.on("keypress", s);
  }
  function o() {
    r == null || r.close(), r = void 0, process.stdin.off("keypress", s), process.stdin.isTTY && process.stdin.setRawMode(!1);
  }
  return n(), {
    on: n,
    off: o,
    running: () => e
  };
}
let D;
function _(t) {
  D = t;
}
he((t) => {
  D == null || D(t);
});
const ge = "viteburner", we = "0.4.0", ve = "Daemon tools of bitburner using vite for script transform, file syncing, RAM monitoring and more!", ye = {
  viteburner: "bin/viteburner.js"
}, be = "./dist/entry.js", Se = "./dist/entry.mjs", $e = {
  ".": {
    require: "./dist/index.js",
    import: "./dist/index.mjs"
  }
}, Re = "dist/typings/index.d.ts", Me = {
  build: "vite build",
  test: "npm run lint && npm run test:spec",
  "test:spec": "vitest run",
  "test:playground": "vite-node ./src/entry.ts -- --cwd ./playground",
  postversion: "npm run build",
  lint: "npm run lint:ts && npm run lint:eslint && npm run lint:prettier",
  "lint:ts": "tsc --noEmit",
  "lint:eslint": "eslint --ext .ts,.tsx,.js,.jsx .",
  "lint:prettier": 'prettier --check "**/*.{js,mjs,cjs,jsx,ts,mts,cts,tsx,json}"',
  format: 'prettier --write "**/*.{js,mjs,cjs,jsx,ts,mts,cts,tsx,json}"'
}, Fe = {
  type: "git",
  url: "git+https://github.com/Tanimodori/viteburner.git"
}, Ue = [
  "bitburner",
  "vite"
], je = "Tanimodori", xe = "MIT", De = {
  url: "https://github.com/Tanimodori/viteburner/issues"
}, ke = "https://github.com/Tanimodori/viteburner#readme", Ie = {
  "@types/estree": "^1.0.0",
  "@types/micromatch": "^4.0.2",
  "@types/node": "^18.8.2",
  "@types/prompts": "^2.4.1",
  "@types/ws": "^8.5.3",
  "@typescript-eslint/eslint-plugin": "^5.39.0",
  "@typescript-eslint/parser": "^5.39.0",
  "builtin-modules": "^3.3.0",
  eslint: "^8.24.0",
  "eslint-config-prettier": "^8.5.0",
  "eslint-plugin-prettier": "^4.2.1",
  prettier: "^2.7.1",
  typescript: "^4.8.4",
  vite: "^3.1.8",
  "vite-node": "^0.24.0",
  "vite-plugin-dts": "^1.6.6",
  vitest: "^0.24.3"
}, Te = {
  acorn: "^8.8.1",
  cac: "^6.7.14",
  chokidar: "^3.5.3",
  "fast-glob": "^3.2.12",
  "magic-string": "^0.26.7",
  micromatch: "^4.0.5",
  pathe: "^0.3.9",
  picocolors: "^1.0.0",
  prompts: "^2.4.2",
  unconfig: "^0.3.7",
  ws: "^8.9.0",
  zod: "^3.19.1"
}, Ee = {
  vite: "^3.0.0"
}, O = {
  name: ge,
  version: we,
  description: ve,
  bin: ye,
  main: be,
  module: Se,
  exports: $e,
  typings: Re,
  scripts: Me,
  repository: Fe,
  keywords: Ue,
  author: je,
  license: xe,
  bugs: De,
  homepage: ke,
  devDependencies: Ie,
  dependencies: Te,
  peerDependencies: Ee
};
function We(t) {
  return (e) => {
    const s = qe(e);
    let r = t != null ? t : "home";
    if (typeof r == "function") {
      const n = r(e);
      if (!n)
        return [];
      r = n;
    }
    return Array.isArray(r) || (r = [r]), r.map((n) => {
      const o = {
        filename: s,
        server: "home",
        ...typeof n == "string" ? { server: n } : n
      };
      return o.filename = G(o.filename), o;
    });
  };
}
function Le(t) {
  return typeof t == "string" ? t : t === !1 ? void 0 : "NetscriptDefinitions.d.ts";
}
function Ne(t) {
  return typeof t == "string" ? (e) => t + "/" + e : typeof t == "function" ? t : void 0;
}
function He(t) {
  var n, o, c, l, u, d, w, v, S, R, f, m, p, y;
  const e = (n = t.watch) != null ? n : [], s = (c = (o = t.download) == null ? void 0 : o.server) != null ? c : "home";
  return {
    watch: e.map((b) => {
      var U;
      return {
        pattern: b.pattern,
        transform: (U = b.transform) != null ? U : !1,
        location: We(b.location)
      };
    }),
    sourcemap: (l = t.sourcemap) != null ? l : !1,
    port: (u = t.port) != null ? u : 12525,
    timeout: (d = t.timeout) != null ? d : 1e4,
    dts: Le(t.dts),
    ignoreInitial: (w = t.ignoreInitial) != null ? w : !1,
    download: {
      server: Array.isArray(s) ? s : [s],
      location: (S = (v = t == null ? void 0 : t.download) == null ? void 0 : v.location) != null ? S : (b) => "src/" + b,
      ignoreTs: (f = (R = t == null ? void 0 : t.download) == null ? void 0 : R.ignoreTs) != null ? f : !0,
      ignoreSourcemap: (p = (m = t == null ? void 0 : t.download) == null ? void 0 : m.ignoreSourcemap) != null ? p : !0
    },
    dumpFiles: Ne(t.dumpFiles),
    cwd: (y = t.cwd) != null ? y : process.cwd()
  };
}
function xt(t) {
  return t;
}
async function Ce(t) {
  var s;
  const { config: e } = await Z({
    sources: [
      {
        files: "viteburner.config",
        extensions: ["ts", "mts", "cts", "js", "mjs", "cjs", "json", ""]
      },
      {
        files: "vite.config",
        async rewrite(r) {
          var c;
          const n = await (typeof r == "function" ? r() : r), o = (c = n == null ? void 0 : n.build) == null ? void 0 : c.sourcemap;
          return {
            ...o && { sourcemap: o },
            ...n == null ? void 0 : n.viteburner
          };
        }
      }
    ],
    cwd: (s = t.cwd) != null ? s : process.cwd(),
    merge: !0
  });
  return He({
    ...e,
    ...t
  });
}
process.platform;
function F(t) {
  return t.replace(/\\/g, "/");
}
function z(t, e) {
  return e && t.startsWith(e) && (t = `/${t.slice(e.length)}`), t.replace(/^\/@id\/__x00__/, "\0").replace(/^\/@id\//, "").replace(/^__vite-browser-external:/, "").replace(/^(node|file):/, "").replace(/^\/+/, "/").replace(/\?v=\w+/, "?").replace(/&v=\w+/, "").replace(/\?t=\w+/, "?").replace(/&t=\w+/, "").replace(/\?import/, "?").replace(/&import/, "").replace(/\?&/, "?").replace(/\?+$/, "");
}
class Pe {
  constructor(e, s = {}) {
    h(this, "items");
    h(this, "options");
    h(this, "watcher");
    h(this, "initial");
    h(this, "enabled");
    h(this, "enabledTimeStamp");
    h(this, "emitter");
    this.items = e, this.options = s, this.initial = !0, this.enabled = !0, this.enabledTimeStamp = 0, this.emitter = new le();
  }
  get patterns() {
    return this.items.map((e) => e.pattern);
  }
  findItem(e) {
    return this.items.find((s) => ne(e, s.pattern));
  }
  init() {
    this.watcher = ce.watch(this.patterns, this.options), this.watcher.on("ready", () => {
      this.initial = !1;
    });
    const e = ["add", "unlink", "change"];
    for (const s of e)
      this.watcher.on(s, (r) => {
        this.triggerHmr(r, s);
      });
  }
  triggerHmr(e, s) {
    var o;
    if (!this.enabled)
      return;
    const r = (o = this.options.cwd) != null ? o : process.cwd();
    if (s !== "unlink" && $.statSync(k(r, e)).mtimeMs <= this.enabledTimeStamp)
      return;
    const n = this.findItem(e);
    if (n)
      this.emitter.emit(A, {
        ...n,
        file: F(e),
        event: s,
        initial: this.initial,
        timestamp: Date.now()
      });
    else
      throw new Error(`File ${e} does not match any patterns`);
  }
  setEnabled(e) {
    this.enabled = e, e && (this.enabledTimeStamp = Date.now());
  }
  async fullReload() {
    var s;
    this.enabledTimeStamp = 0;
    const e = H.stream(this.patterns, { cwd: (s = this.options.cwd) != null ? s : process.cwd() });
    for await (const r of e)
      this.triggerHmr(r, "change");
  }
  getUploadFilenames(e) {
    e = I(F(e));
    const s = this.findItem(e);
    return s ? s.location(e) : [];
  }
  getUploadFilenamesByServer(e, s) {
    var n;
    return (n = this.getUploadFilenames(e).find((o) => o.server === s)) == null ? void 0 : n.filename;
  }
  close() {
    var e;
    (e = this.watcher) == null || e.close();
  }
}
function _e(t) {
  if (!t)
    return "";
  const e = JSON.stringify(t);
  return `//# sourceMappingURL=data:application/json;base64,${Buffer.from(e).toString("base64")}`;
}
async function E(t, e) {
  const s = x.dirname(t);
  return $.existsSync(s) || await $.promises.mkdir(s, { recursive: !0 }), $.promises.writeFile(t, e, {
    flag: "w",
    encoding: "utf8"
  });
}
function B(t) {
  return t.endsWith(".js") || t.endsWith(".script");
}
const C = (t) => t.startsWith("/") ? t : "/" + t, G = (t) => {
  const e = t.lastIndexOf("/");
  return e === 0 ? t.substring(1) : e !== -1 ? C(t) : t;
}, I = (t) => t.startsWith("/") ? t.substring(1) : t, qe = (t) => t.replace(/^src\//, "").replace(/\.ts$/, ".js");
function Ke() {
  i.info(
    "help",
    a.dim("press ") + a.reset(a.bold("h")) + a.dim(" to show help, press ") + a.reset(a.bold("q")) + a.dim(" to exit")
  );
}
function q() {
  i.info("vite", a.reset("watching for file changes...")), Ke();
}
function Oe(t) {
  const s = (f, m) => {
    i.info("status", a.reset(f.padStart(18)), m);
  }, r = () => {
    i.info("status"), i.info("status", " ".repeat(14) + a.reset(a.bold(a.inverse(a.green(" STATUS "))))), s("connection:", t.manager.connected ? a.green("connected") : a.yellow("disconnected")), s("port:", a.magenta(t.server.config.viteburner.port));
    const f = t.buffers.size, m = `${f} file${f === 1 ? "" : "s"}`, p = f ? a.yellow(m) : a.dim(m);
    s("pending:", p), i.info("status", a.dim(""));
  };
  r(), q();
  const n = () => {
    i.info("help");
    const f = [
      ["u", "upload all files"],
      ["d", "download all files"],
      ["s", "show status"],
      ["r", "show RAM usage of scripts"],
      ["q", "quit"]
    ];
    i.info("help", a.reset(a.bold("Watch Usage")));
    for (const [m, p] of f)
      i.info("help", `press ${a.reset(a.bold(m))}${a.dim(" to ")}${p}`);
    i.info("help", a.dim(""));
  }, o = () => t.manager.connected ? !0 : (i.error("conn", a.red("no connection")), !1), c = () => {
    i.info("upload", a.reset("force full-upload triggered")), t.server.watchManager.fullReload();
  }, l = () => {
    i.info("download", a.reset("force full-download triggered")), t.fullDownload();
  }, u = async () => (i.info("ram", a.reset("fetching ram usage of scripts...")), await t.getRamUsage(), !0), d = async () => {
    const { pattern: f } = await j({
      type: "text",
      name: "pattern",
      message: "Enter a glob pattern",
      initial: "src/**/*.{ts,js}"
    });
    return f ? (i.info("ram", a.reset("fetching ram usage of scripts...")), await t.getRamUsage(f), !0) : !1;
  }, w = async () => {
    const m = await H("**/*.{js,ts,script}", { cwd: t.server.config.root });
    m.sort();
    const p = /* @__PURE__ */ new Map();
    for (const b of m) {
      if (b.endsWith(".d.ts") || b === t.server.config.viteburner.dts)
        continue;
      const U = t.getRamUsageLocalData(b);
      U.length !== 0 && p.set(b, U);
    }
    const { file: y } = await j({
      type: "autocomplete",
      name: "file",
      message: "Enter a filename",
      choices: [...p.keys()].map((b) => ({ title: b }))
    });
    return y ? $.existsSync(k(t.server.config.root, y)) ? (p.has(y) ? await t.getRamUsageLocalRaw(y, p.get(y)) : await t.getRamUsageLocal(y), !0) : (i.error("ram", `file ${y} does not exist`), !1) : !1;
  }, v = async () => {
    const { server: f } = await j({
      type: "text",
      name: "server",
      message: "Enter a server name",
      initial: "home"
    });
    if (!f)
      return !1;
    const m = await t.getFileNames(f);
    if (!m)
      return !1;
    const { filename: p } = await j({
      type: "autocomplete",
      name: "filename",
      message: "Enter a filename",
      choices: m.filter(B).map((y) => ({ title: y }))
    });
    return p ? (await t.getRamUsageRemote(f, p), !0) : !1;
  }, S = async () => {
    const { filter: f } = await j({
      type: "select",
      name: "filter",
      message: "Which script do you want to check?",
      initial: 0,
      choices: [
        { title: "All local scripts", value: "all" },
        { title: "Filter local scripts by glob pattern", value: "glob" },
        { title: "Find a local script", value: "local" },
        { title: "Find a remote script", value: "remote" }
      ]
    });
    return f ? f === "all" ? u() : f === "glob" ? d() : f === "local" ? w() : f === "remote" ? v() : !1 : !1;
  }, R = async (f) => {
    f.off(), await S() ? i.info("ram", "done") : i.info("ram", "cancelled"), f.on();
  };
  return async (f) => {
    const { key: m } = f;
    let p = !0;
    m.name === "q" ? (i.info("bye"), process.exit()) : m.name === "s" ? r() : m.name === "h" ? n() : m.name === "u" ? o() && c() : m.name === "d" ? o() && l() : m.name === "r" ? o() && await R(f) : p = !1, p && q();
  };
}
function ze(t) {
  return se(t, {
    ecmaVersion: "latest",
    sourceType: "module",
    locations: !0
  });
}
function Be(t, e) {
  const s = z(e != null ? e : t.filename), r = t.manager.getUploadFilenamesByServer(s, t.server);
  if (r)
    return r;
  {
    const n = e ? `Path "${e}" imported by "${t.filename}" not found on server "${t.server}"` : `File "${e}" not found on server "${t.server}"`;
    return i.warn("import", n), i.warn("import", "This may be a problem when the script is running on the server."), s;
  }
}
function Ge(t) {
  const e = new re(t.content), s = ze(t.content);
  for (const r of s.body)
    if (r.type === "ImportDeclaration") {
      const n = r.source, o = n.raw, c = n.value, l = C(Be(t, c)), u = o[0];
      e.overwrite(n.start, n.end, u + l + u);
    }
  return e.toString();
}
const W = (t, e, s) => {
  e = C(e);
  const r = `@${s}:${e}`;
  return {
    styled: `${a.dim(t)} ${a.reset("->")} ${a.dim(r)}`,
    raw: `${t} -> ${r}`
  };
}, Ae = (t, e, s) => {
  e = I(e);
  const r = `@${s}:/${t}`;
  return {
    styled: `${a.dim(r)} ${a.reset("->")} ${a.dim(e)}`,
    raw: `${r} -> ${e}`
  };
}, Dt = (t) => "src/" + t, kt = "NetscriptDefinitions.d.ts";
class Je {
  constructor(e, s) {
    h(this, "buffers", /* @__PURE__ */ new Map());
    h(this, "manager");
    h(this, "server");
    this.manager = e, this.server = s, this.manager.onConnected(async (r) => {
      i.info("conn", "", "connected");
      const n = () => {
        i.info("conn", "", a.yellow("disconnected"));
      };
      return r.on("close", n), await this.getDts(), await this.handleHmrMessage(), () => {
        r.off("close", n);
      };
    }), this.manager.checkIfWssReused();
  }
  async getDts() {
    const e = this.server.config.viteburner.dts;
    if (!!e)
      try {
        const s = await this.manager.getDefinitionFile(), r = this.server.config.root, n = x.resolve(r, e);
        await E(n, s), i.info("dts change", e);
      } catch (s) {
        i.error(`error getting dts file: ${s}`);
      }
  }
  async checkDependencies(e) {
    var s;
    for (const r of e) {
      if (r.event === "change")
        continue;
      const n = F(k(this.server.config.root, r.file));
      (s = this.server._importGlobMap) == null || s.forEach((o, c) => {
        if (o.some((l) => ie([n], l).length > 0)) {
          const l = F(ee(this.server.config.root, c));
          if (e.some((d) => d.file === l))
            return;
          const u = this.server.watchManager.findItem(l);
          u != null && u.transform && e.push({
            file: l,
            timestamp: r.timestamp,
            initial: r.initial,
            event: "change",
            ...u
          });
        }
      });
    }
    return e;
  }
  async handleHmrMessage(e) {
    e ? Array.isArray(e) || (e = [e]) : e = [], e = await this.checkDependencies(e);
    const s = this.manager.connected;
    for (const r of e)
      this.buffers.set(r.file, r), i.info(`hmr ${r.event}`, r.file, a.yellow("(pending)"));
    if (!!s && this.buffers.size)
      for (const r of this.buffers.values())
        await this.uploadFile(r);
  }
  deleteCache(e) {
    const s = this.buffers.get(e.file);
    s && e.timestamp === s.timestamp && this.buffers.delete(e.file);
  }
  async dumpFile(e, s, r) {
    var c, l;
    const n = (l = (c = this.server.config.viteburner).dumpFiles) == null ? void 0 : l.call(c, e.file, r);
    if (!n)
      return;
    const o = x.resolve(this.server.config.root, n);
    await E(o, s), i.info("dump", W(e.file, F(n), r).styled);
  }
  async fetchModule(e) {
    let s = "";
    if (e.transform) {
      const r = await this.server.fetchModule(e.file);
      if (!r)
        throw new Error("module not found: " + e.file);
      s = r.code, this.server.config.viteburner.sourcemap === "inline" && r.map && (s += _e(r.map));
    } else
      s = (await $.promises.readFile(x.resolve(this.server.config.root, e.file))).toString();
    return s;
  }
  fixImport(e, s, r) {
    return s.transform ? Ge({
      content: e,
      filename: s.file,
      server: r,
      manager: this.server.watchManager
    }) : e;
  }
  async uploadFile(e) {
    this.deleteCache(e);
    const s = e.event !== "unlink";
    let r = "";
    if (s)
      try {
        r = await this.fetchModule(e);
      } catch (o) {
        i.error(String(o));
        return;
      }
    const n = this.server.watchManager.getUploadFilenames(e.file);
    if (!n.length) {
      i.info(`hmr ${e.event}`, e.file, a.dim("(ignored)"));
      return;
    }
    for (const { filename: o, server: c } of n) {
      const l = W(e.file, o, c);
      try {
        s ? (e.transform && (r = this.fixImport(r, e, c)), this.dumpFile(e, r, c), await this.manager.pushFile({
          filename: o,
          content: r,
          server: c
        })) : await this.manager.deleteFile({
          filename: o,
          server: c
        }), i.info(`hmr ${e.event}`, l.styled, a.green("(done)"));
      } catch (u) {
        i.error(`error ${e.event}: ${l.raw} ${u}`), i.error(`hmr ${e.event} ${e.file} (error)`);
        continue;
      }
    }
  }
  async fullDownload() {
    i.info("vite", a.reset("stop watching for file changes while downloading")), this.server.watchManager.setEnabled(!1);
    const e = this.server.config.viteburner.download.server, s = /* @__PURE__ */ new Map();
    for (const r of e)
      try {
        s.set(r, await this.manager.getAllFiles({ server: r }));
      } catch (n) {
        i.error(`error: connot get filelist from server ${r}: ${n}`);
        continue;
      }
    for (const [r, n] of s) {
      const { location: o, ignoreTs: c, ignoreSourcemap: l } = this.server.config.viteburner.download;
      for (const u of n) {
        u.filename = I(u.filename);
        const d = o(u.filename, r);
        if (!d) {
          i.info("download", `@${r}:/${u.filename}`, a.dim("(ignored)"));
          continue;
        }
        const w = k(this.server.config.root, d), v = Ae(u.filename, d, r);
        try {
          const S = () => c && w.endsWith(".js") && $.existsSync(w.substring(0, w.length - 3) + ".ts"), R = () => l && u.content.match(/\/\/# sourceMappingURL=\S+\s*$/g);
          if (S() || R()) {
            i.info("download", v.styled, a.dim("(ignored)"));
            continue;
          }
          await E(w, u.content), i.info("download", v.styled, a.green("(done)"));
        } catch (S) {
          i.error("download", v.raw, `(${S})`);
        }
      }
    }
    i.info("vite", a.reset("download completed, watching for file changes...")), this.server.watchManager.setEnabled(!0);
  }
  async getRamUsage(e) {
    const s = e != null ? e : this.server.watchManager.patterns;
    if (!s) {
      i.warn("ram", "no pattern found");
      return;
    }
    const r = await H(s, { cwd: this.server.config.root });
    if (r.length === 0) {
      i.warn("ram", "no file found");
      return;
    }
    r.sort();
    for (const n of r)
      await this.getRamUsageLocal(n);
  }
  getRamUsageLocalData(e) {
    return this.server.watchManager.getUploadFilenames(e);
  }
  async getRamUsageLocalRaw(e, s) {
    let r = !1, n = -1;
    if (s.length === 0)
      return i.info("ram", `${e} (ignored)`), !0;
    for (const { filename: o, server: c } of s) {
      const l = W(e, o, c);
      if (!!B(o)) {
        r = !0;
        try {
          n = await this.manager.calculateRam({ filename: o, server: c }), i.info("ram", a.reset(`${e}: ${n} GB`));
          break;
        } catch (u) {
          i.warn("ram", l.raw, `(${u})`);
        }
      }
    }
    if (r) {
      if (n === -1)
        return i.warn("ram", e, "(no target found)"), !1;
    } else
      i.info("ram", e, a.dim("(ignored)"));
    return !0;
  }
  async getRamUsageLocal(e) {
    const s = this.getRamUsageLocalData(e);
    return this.getRamUsageLocalRaw(e, s);
  }
  async getRamUsageRemote(e, s) {
    const r = G(s);
    i.info("ram", a.reset("fetching ram usage of scripts..."));
    try {
      const n = await this.manager.calculateRam({ filename: r, server: e });
      i.info("ram", a.reset(`@${e}/${s}: ${n} GB`));
    } catch (n) {
      i.error("ram", `@${e}/${s}: ${n}`);
    }
  }
  async getFileNames(e) {
    try {
      return (await this.manager.getFileNames({ server: e })).map(I);
    } catch (s) {
      return i.error("list", `cannot fetch filenames from server ${e}: ${s}`), null;
    }
  }
}
let L = !1, M = null, K = -1;
function Ye(t) {
  return M === null || K !== t ? (M && (M.clients.forEach((e) => e.close()), M.close()), K = t, M = new oe({ port: t }), L = !1) : L = !0, M;
}
function Ve() {
  return L;
}
const Qe = g.object({
  jsonrpc: g.literal("2.0"),
  id: g.number(),
  result: g.any(),
  error: g.any()
}), Xe = g.literal("OK"), Ze = g.string(), et = g.literal("OK"), tt = g.array(g.string()), st = g.array(
  g.object({
    filename: g.string(),
    content: g.string()
  })
), rt = g.number(), nt = g.string();
class it {
  constructor(e) {
    h(this, "options");
    h(this, "ws");
    h(this, "wss");
    h(this, "trackers");
    h(this, "nextId");
    h(this, "unregisters");
    this.options = {
      timeout: 1e4,
      ...e
    }, this.trackers = [], this.nextId = 0, this.ws = void 0, this.wss = Ye(this.options.port), this.unregisters = [], this._registerHandler();
  }
  get connected() {
    var e;
    return ((e = this.ws) == null ? void 0 : e.readyState) === ae.OPEN;
  }
  _registerHandler() {
    const e = (r) => {
      this.ws = r, r.on("message", (n) => this.handleMessage(n));
    }, s = (r) => {
      const n = String(r);
      n.indexOf("EADDRINUSE") !== -1 ? (i.error("ws", `fatal: port ${this.options.port} is already in use`), process.exit(1)) : i.error("ws", `${n}`);
    };
    this.wss.on("connection", e), this.wss.on("error", s), this.unregisters.push(() => {
      this.wss.off("connection", e), this.wss.off("error", s);
    });
  }
  onConnected(e) {
    const s = async (r) => {
      this.ws = r;
      const n = await e(r);
      n && this.unregisters.push(n);
    };
    this.wss.on("connection", s), this.unregisters.push(() => {
      this.wss.off("connection", s);
    });
  }
  checkIfWssReused() {
    if (Ve() && this.wss.clients.size > 0) {
      for (const e of this.wss.clients)
        this.ws = e;
      this.wss.emit("connection", this.ws);
    }
  }
  handleMessage(e) {
    const s = Qe.parse(JSON.parse(e.toString())), { id: r, result: n, error: o } = s;
    if (!this.trackers[r])
      return;
    const { resolve: c, reject: l } = this.trackers[r];
    o && l(o), c(n);
  }
  async sendMessage(e) {
    const s = e.params;
    if (!this.ws || !this.connected)
      throw new Error("No connection");
    const r = ++this.nextId;
    this.ws.send(
      JSON.stringify({
        jsonrpc: "2.0",
        id: r,
        method: e.method,
        ...s && { params: s }
      })
    );
    const n = new Promise((o, c) => {
      const l = (d) => {
        var w, v;
        try {
          o((v = (w = e.validator) == null ? void 0 : w.parse(d)) != null ? v : d);
        } catch (S) {
          c(S);
        } finally {
          delete this.trackers[r];
        }
      }, u = (d) => {
        delete this.trackers[r], c(d);
      };
      this.trackers[r] = {
        resolve: l,
        reject: u
      };
    });
    return this.options.timeout && setTimeout(() => {
      this.trackers[r] && this.trackers[r].reject(new Error(`Timeout after ${this.options.timeout}ms`));
    }, this.options.timeout), n;
  }
  async pushFile(e) {
    return this.sendMessage({
      method: "pushFile",
      params: e,
      validator: Xe
    });
  }
  async getFile(e) {
    return this.sendMessage({
      method: "getFile",
      params: e,
      validator: Ze
    });
  }
  async deleteFile(e) {
    return this.sendMessage({
      method: "deleteFile",
      params: e,
      validator: et
    });
  }
  async getFileNames(e) {
    return this.sendMessage({
      method: "getFileNames",
      params: e,
      validator: tt
    });
  }
  async getAllFiles(e) {
    return this.sendMessage({
      method: "getAllFiles",
      params: e,
      validator: st
    });
  }
  async calculateRam(e) {
    return this.sendMessage({
      method: "calculateRam",
      params: e,
      validator: rt
    });
  }
  async getDefinitionFile() {
    return this.sendMessage({
      method: "getDefinitionFile",
      validator: nt
    });
  }
  close() {
    this.unregisters.forEach((e) => e());
  }
}
const A = "viteburner:hmr", N = "virtual:viteburner-entry";
function ot() {
  return {
    mode: "development",
    optimizeDeps: { disabled: !0 },
    clearScreen: !1,
    build: {
      lib: {
        entry: N,
        formats: ["es"]
      }
    },
    server: { middlewareMode: !0 }
  };
}
function at(t) {
  const e = "\0" + N;
  let s, r;
  return {
    name: "viteburner",
    apply: "serve",
    async config(n) {
      return i.info("config", "resolving user config..."), n.viteburner = await Ce(t), ot();
    },
    configResolved() {
      i.info("config", "config resolved");
    },
    configureServer(n) {
      s = {
        ...n,
        pathToId(o) {
          const c = `/@fs/${F(te(s.config.root, o))}`;
          return z(c, s.config.base);
        },
        async invalidateFile(o) {
          const c = s.pathToId(o), l = await s.moduleGraph.getModuleByUrl(c);
          l && s.moduleGraph.invalidateModule(l);
        },
        async fetchModule(o) {
          const c = s.pathToId(o);
          return s.transformRequest(c);
        },
        onHmrMessage(o) {
          s.watchManager.emitter.on(A, (c) => o(c, s));
        },
        async buildStart() {
          return s.pluginContainer.buildStart({});
        }
      };
    },
    buildStart() {
      i.info("watch", "creating a watcher...");
      const { root: n, viteburner: o } = s.config, { watch: c, ignoreInitial: l, port: u, timeout: d } = o;
      s.watchManager = new Pe(c, {
        cwd: n,
        persistent: !0,
        ignoreInitial: l
      }), i.info("ws", "creating ws server...");
      const w = new it({ port: u, timeout: d });
      r = new Je(w, s), s.onHmrMessage((v) => r.handleHmrMessage(v)), s.watchManager.init(), _(Oe(r));
    },
    resolveId(n) {
      if (n === N)
        return e;
    },
    load(n) {
      if (n === e)
        return "export {}";
    },
    buildEnd() {
      s.watchManager.close(), r.manager.close(), _();
    }
  };
}
const T = V("viteburner");
T.command("", "start dev server").alias("serve").alias("dev").option("--cwd <cwd>", "Working directory").option("--port <port>", "Port to listen on").action(ct);
T.help();
T.version(O.version);
async function ct(t) {
  const e = t.cwd, s = t.port, r = {
    ...e && { cwd: e },
    ...s && { port: s }
  };
  i.info("version", O.version), i.info("vite", "creating dev server..."), X({
    ...e && { root: e },
    viteburner: r,
    plugins: [at(r)]
  });
}
async function It() {
  T.parse();
}
export {
  qe as A,
  Ke as B,
  q as C,
  Oe as D,
  W as E,
  Ae as F,
  Dt as G,
  kt as H,
  Je as I,
  Ye as J,
  Ve as K,
  Ge as L,
  it as M,
  Qe as N,
  Xe as O,
  Ze as P,
  et as Q,
  tt as R,
  st as S,
  rt as T,
  nt as U,
  Pe as W,
  Le as a,
  Ne as b,
  He as c,
  xt as d,
  me as e,
  ue as f,
  de as g,
  pe as h,
  i,
  _ as j,
  A as k,
  Ce as l,
  It as m,
  ot as n,
  he as o,
  fe as p,
  at as q,
  We as r,
  ct as s,
  _e as t,
  B as u,
  N as v,
  E as w,
  C as x,
  G as y,
  I as z
};
